﻿// Decompiled with JetBrains decompiler
// Type: ICSharpCode.SharpZipLib.Zip.Compression.DeflaterEngine
// Assembly: Done, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: EBE6DCED-6866-44D2-B309-A0C25849858B
// Assembly location: C:\Users\Administrateur\Downloads\Virusshare.00004-msil\Worm.MSIL.Autorun.jk-5bcc93e5d4639a5f95eb9ff6188099454019b185da8721fd79d0305ee3797532.exe

using ICSharpCode.SharpZipLib.Checksums;
using System;

namespace ICSharpCode.SharpZipLib.Zip.Compression
{
  public class DeflaterEngine : DeflaterConstants
  {
    private static int TOO_FAR = 4096;
    private int ins_h;
    private short[] head;
    private short[] prev;
    private int matchStart;
    private int matchLen;
    private bool prevAvailable;
    private int blockStart;
    private int strstart;
    private int lookahead;
    private byte[] window;
    private DeflateStrategy strategy;
    private int max_chain;
    private int max_lazy;
    private int niceLength;
    private int goodLength;
    private int comprFunc;
    private byte[] inputBuf;
    private int totalIn;
    private int inputOff;
    private int inputEnd;
    private DeflaterPending pending;
    private DeflaterHuffman huffman;
    private Adler32 adler;

    public DeflaterEngine(DeflaterPending pending)
    {
      this.pending = pending;
      this.huffman = new DeflaterHuffman(pending);
      this.adler = new Adler32();
      this.window = new byte[65536];
      this.head = new short[32768];
      this.prev = new short[32768];
      this.blockStart = this.strstart = 1;
    }

    public void Reset()
    {
      this.huffman.Reset();
      this.adler.Reset();
      this.blockStart = this.strstart = 1;
      this.lookahead = 0;
      this.totalIn = 0;
      this.prevAvailable = false;
      this.matchLen = 2;
      for (int index = 0; index < 32768; ++index)
        this.head[index] = (short) 0;
      for (int index = 0; index < 32768; ++index)
        this.prev[index] = (short) 0;
    }

    public void ResetAdler() => this.adler.Reset();

    public int Adler => (int) this.adler.Value;

    public int TotalIn => this.totalIn;

    public DeflateStrategy Strategy
    {
      get => this.strategy;
      set => this.strategy = value;
    }

    public void SetLevel(int lvl)
    {
      this.goodLength = DeflaterConstants.GOOD_LENGTH[lvl];
      this.max_lazy = DeflaterConstants.MAX_LAZY[lvl];
      this.niceLength = DeflaterConstants.NICE_LENGTH[lvl];
      this.max_chain = DeflaterConstants.MAX_CHAIN[lvl];
      if (DeflaterConstants.COMPR_FUNC[lvl] == this.comprFunc)
        return;
      switch (this.comprFunc)
      {
        case 0:
          if (this.strstart > this.blockStart)
          {
            this.huffman.FlushStoredBlock(this.window, this.blockStart, this.strstart - this.blockStart, false);
            this.blockStart = this.strstart;
          }
          this.UpdateHash();
          break;
        case 1:
          if (this.strstart > this.blockStart)
          {
            this.huffman.FlushBlock(this.window, this.blockStart, this.strstart - this.blockStart, false);
            this.blockStart = this.strstart;
            break;
          }
          break;
        case 2:
          if (this.prevAvailable)
            this.huffman.TallyLit((int) this.window[this.strstart - 1] & (int) byte.MaxValue);
          if (this.strstart > this.blockStart)
          {
            this.huffman.FlushBlock(this.window, this.blockStart, this.strstart - this.blockStart, false);
            this.blockStart = this.strstart;
          }
          this.prevAvailable = false;
          this.matchLen = 2;
          break;
      }
      this.comprFunc = DeflaterConstants.COMPR_FUNC[lvl];
    }

    private void UpdateHash() => this.ins_h = (int) this.window[this.strstart] << 5 ^ (int) this.window[this.strstart + 1];

    private int InsertString()
    {
      int index = (this.ins_h << 5 ^ (int) this.window[this.strstart + 2]) & (int) short.MaxValue;
      short num;
      this.prev[this.strstart & (int) short.MaxValue] = num = this.head[index];
      this.head[index] = (short) this.strstart;
      this.ins_h = index;
      return (int) num & (int) ushort.MaxValue;
    }

    private void SlideWindow()
    {
      Array.Copy((Array) this.window, 32768, (Array) this.window, 0, 32768);
      this.matchStart -= 32768;
      this.strstart -= 32768;
      this.blockStart -= 32768;
      for (int index = 0; index < 32768; ++index)
      {
        int num = (int) this.head[index] & (int) ushort.MaxValue;
        this.head[index] = num >= 32768 ? (short) (num - 32768) : (short) 0;
      }
      for (int index = 0; index < 32768; ++index)
      {
        int num = (int) this.prev[index] & (int) ushort.MaxValue;
        this.prev[index] = num >= 32768 ? (short) (num - 32768) : (short) 0;
      }
    }

    public void FillWindow()
    {
      if (this.strstart >= 65274)
        this.SlideWindow();
      int num;
      for (; this.lookahead < 262 && this.inputOff < this.inputEnd; this.lookahead += num)
      {
        num = 65536 - this.lookahead - this.strstart;
        if (num > this.inputEnd - this.inputOff)
          num = this.inputEnd - this.inputOff;
        Array.Copy((Array) this.inputBuf, this.inputOff, (Array) this.window, this.strstart + this.lookahead, num);
        this.adler.Update(this.inputBuf, this.inputOff, num);
        this.inputOff += num;
        this.totalIn += num;
      }
      if (this.lookahead < 3)
        return;
      this.UpdateHash();
    }

    private bool FindLongestMatch(int curMatch)
    {
      int maxChain = this.max_chain;
      int num1 = this.niceLength;
      short[] prev = this.prev;
      int strstart = this.strstart;
      int index = this.strstart + this.matchLen;
      int val1 = Math.Max(this.matchLen, 2);
      int num2 = Math.Max(this.strstart - 32506, 0);
      int num3 = this.strstart + 258 - 1;
      byte num4 = this.window[index - 1];
      byte num5 = this.window[index];
      if (val1 >= this.goodLength)
        maxChain >>= 2;
      if (num1 > this.lookahead)
        num1 = this.lookahead;
      do
      {
        if ((int) this.window[curMatch + val1] == (int) num5 && (int) this.window[curMatch + val1 - 1] == (int) num4 && (int) this.window[curMatch] == (int) this.window[strstart] && (int) this.window[curMatch + 1] == (int) this.window[strstart + 1])
        {
          int num6 = curMatch + 2;
          int num7 = strstart + 2;
          int num8;
          int num9;
          int num10;
          int num11;
          int num12;
          int num13;
          int num14;
          do
            ;
          while ((int) this.window[++num7] == (int) this.window[num8 = num6 + 1] && (int) this.window[++num7] == (int) this.window[num9 = num8 + 1] && (int) this.window[++num7] == (int) this.window[num10 = num9 + 1] && (int) this.window[++num7] == (int) this.window[num11 = num10 + 1] && (int) this.window[++num7] == (int) this.window[num12 = num11 + 1] && (int) this.window[++num7] == (int) this.window[num13 = num12 + 1] && (int) this.window[++num7] == (int) this.window[num14 = num13 + 1] && (int) this.window[++num7] == (int) this.window[num6 = num14 + 1] && num7 < num3);
          if (num7 > index)
          {
            this.matchStart = curMatch;
            index = num7;
            val1 = num7 - this.strstart;
            if (val1 < num1)
            {
              num4 = this.window[index - 1];
              num5 = this.window[index];
            }
            else
              break;
          }
          strstart = this.strstart;
        }
      }
      while ((curMatch = (int) prev[curMatch & (int) short.MaxValue] & (int) ushort.MaxValue) > num2 && --maxChain != 0);
      this.matchLen = Math.Min(val1, this.lookahead);
      return this.matchLen >= 3;
    }

    public void SetDictionary(byte[] buffer, int offset, int length)
    {
      this.adler.Update(buffer, offset, length);
      if (length < 3)
        return;
      if (length > 32506)
      {
        offset += length - 32506;
        length = 32506;
      }
      Array.Copy((Array) buffer, offset, (Array) this.window, this.strstart, length);
      this.UpdateHash();
      --length;
      while (--length > 0)
      {
        this.InsertString();
        ++this.strstart;
      }
      this.strstart += 2;
      this.blockStart = this.strstart;
    }

    private bool DeflateStored(bool flush, bool finish)
    {
      if (!flush && this.lookahead == 0)
        return false;
      this.strstart += this.lookahead;
      this.lookahead = 0;
      int stored_len = this.strstart - this.blockStart;
      if (stored_len < DeflaterConstants.MAX_BLOCK_SIZE && (this.blockStart >= 32768 || stored_len < 32506) && !flush)
        return true;
      bool lastBlock = finish;
      if (stored_len > DeflaterConstants.MAX_BLOCK_SIZE)
      {
        stored_len = DeflaterConstants.MAX_BLOCK_SIZE;
        lastBlock = false;
      }
      this.huffman.FlushStoredBlock(this.window, this.blockStart, stored_len, lastBlock);
      this.blockStart += stored_len;
      return !lastBlock;
    }

    private bool DeflateFast(bool flush, bool finish)
    {
      if (this.lookahead < 262 && !flush)
        return false;
      while (this.lookahead >= 262 || flush)
      {
        if (this.lookahead == 0)
        {
          this.huffman.FlushBlock(this.window, this.blockStart, this.strstart - this.blockStart, finish);
          this.blockStart = this.strstart;
          return false;
        }
        if (this.strstart > 65274)
          this.SlideWindow();
        int curMatch;
        if (this.lookahead >= 3 && (curMatch = this.InsertString()) != 0 && this.strategy != DeflateStrategy.HuffmanOnly && this.strstart - curMatch <= 32506 && this.FindLongestMatch(curMatch))
        {
          this.huffman.TallyDist(this.strstart - this.matchStart, this.matchLen);
          this.lookahead -= this.matchLen;
          if (this.matchLen <= this.max_lazy && this.lookahead >= 3)
          {
            while (--this.matchLen > 0)
            {
              ++this.strstart;
              this.InsertString();
            }
            ++this.strstart;
          }
          else
          {
            this.strstart += this.matchLen;
            if (this.lookahead >= 2)
              this.UpdateHash();
          }
          this.matchLen = 2;
        }
        else
        {
          this.huffman.TallyLit((int) this.window[this.strstart] & (int) byte.MaxValue);
          ++this.strstart;
          --this.lookahead;
          if (this.huffman.IsFull())
          {
            bool lastBlock = finish && this.lookahead == 0;
            this.huffman.FlushBlock(this.window, this.blockStart, this.strstart - this.blockStart, lastBlock);
            this.blockStart = this.strstart;
            return !lastBlock;
          }
        }
      }
      return true;
    }

    private bool DeflateSlow(bool flush, bool finish)
    {
      if (this.lookahead < 262 && !flush)
        return false;
      while (this.lookahead >= 262 || flush)
      {
        if (this.lookahead == 0)
        {
          if (this.prevAvailable)
            this.huffman.TallyLit((int) this.window[this.strstart - 1] & (int) byte.MaxValue);
          this.prevAvailable = false;
          this.huffman.FlushBlock(this.window, this.blockStart, this.strstart - this.blockStart, finish);
          this.blockStart = this.strstart;
          return false;
        }
        if (this.strstart >= 65274)
          this.SlideWindow();
        int matchStart = this.matchStart;
        int matchLen = this.matchLen;
        if (this.lookahead >= 3)
        {
          int curMatch = this.InsertString();
          if (this.strategy != DeflateStrategy.HuffmanOnly && curMatch != 0 && this.strstart - curMatch <= 32506 && this.FindLongestMatch(curMatch) && this.matchLen <= 5 && (this.strategy == DeflateStrategy.Filtered || this.matchLen == 3 && this.strstart - this.matchStart > DeflaterEngine.TOO_FAR))
            this.matchLen = 2;
        }
        if (matchLen >= 3 && this.matchLen <= matchLen)
        {
          this.huffman.TallyDist(this.strstart - 1 - matchStart, matchLen);
          int num = matchLen - 2;
          do
          {
            ++this.strstart;
            --this.lookahead;
            if (this.lookahead >= 3)
              this.InsertString();
          }
          while (--num > 0);
          ++this.strstart;
          --this.lookahead;
          this.prevAvailable = false;
          this.matchLen = 2;
        }
        else
        {
          if (this.prevAvailable)
            this.huffman.TallyLit((int) this.window[this.strstart - 1] & (int) byte.MaxValue);
          this.prevAvailable = true;
          ++this.strstart;
          --this.lookahead;
        }
        if (this.huffman.IsFull())
        {
          int stored_len = this.strstart - this.blockStart;
          if (this.prevAvailable)
            --stored_len;
          bool lastBlock = finish && this.lookahead == 0 && !this.prevAvailable;
          this.huffman.FlushBlock(this.window, this.blockStart, stored_len, lastBlock);
          this.blockStart += stored_len;
          return !lastBlock;
        }
      }
      return true;
    }

    public bool Deflate(bool flush, bool finish)
    {
      bool flag;
      do
      {
        this.FillWindow();
        bool flush1 = flush && this.inputOff == this.inputEnd;
        switch (this.comprFunc)
        {
          case 0:
            flag = this.DeflateStored(flush1, finish);
            break;
          case 1:
            flag = this.DeflateFast(flush1, finish);
            break;
          case 2:
            flag = this.DeflateSlow(flush1, finish);
            break;
          default:
            throw new InvalidOperationException("unknown comprFunc");
        }
      }
      while (this.pending.IsFlushed && flag);
      return flag;
    }

    public void SetInput(byte[] buf, int off, int len)
    {
      if (this.inputOff < this.inputEnd)
        throw new InvalidOperationException("Old input was not completely processed");
      int num = off + len;
      if (0 > off || off > num || num > buf.Length)
        throw new ArgumentOutOfRangeException();
      this.inputBuf = buf;
      this.inputOff = off;
      this.inputEnd = num;
    }

    public bool NeedsInput() => this.inputEnd == this.inputOff;
  }
}
