﻿// Decompiled with JetBrains decompiler
// Type: ICSharpCode.SharpZipLib.Zip.Compression.Inflater
// Assembly: Done, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: EBE6DCED-6866-44D2-B309-A0C25849858B
// Assembly location: C:\Users\Administrateur\Downloads\Virusshare.00004-msil\Worm.MSIL.Autorun.jk-5bcc93e5d4639a5f95eb9ff6188099454019b185da8721fd79d0305ee3797532.exe

using ICSharpCode.SharpZipLib.Checksums;
using ICSharpCode.SharpZipLib.Zip.Compression.Streams;
using System;

namespace ICSharpCode.SharpZipLib.Zip.Compression
{
  public class Inflater
  {
    private const int DECODE_HEADER = 0;
    private const int DECODE_DICT = 1;
    private const int DECODE_BLOCKS = 2;
    private const int DECODE_STORED_LEN1 = 3;
    private const int DECODE_STORED_LEN2 = 4;
    private const int DECODE_STORED = 5;
    private const int DECODE_DYN_HEADER = 6;
    private const int DECODE_HUFFMAN = 7;
    private const int DECODE_HUFFMAN_LENBITS = 8;
    private const int DECODE_HUFFMAN_DIST = 9;
    private const int DECODE_HUFFMAN_DISTBITS = 10;
    private const int DECODE_CHKSUM = 11;
    private const int FINISHED = 12;
    private static int[] CPLENS = new int[29]
    {
      3,
      4,
      5,
      6,
      7,
      8,
      9,
      10,
      11,
      13,
      15,
      17,
      19,
      23,
      27,
      31,
      35,
      43,
      51,
      59,
      67,
      83,
      99,
      115,
      131,
      163,
      195,
      227,
      258
    };
    private static int[] CPLEXT = new int[29]
    {
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      1,
      1,
      1,
      1,
      2,
      2,
      2,
      2,
      3,
      3,
      3,
      3,
      4,
      4,
      4,
      4,
      5,
      5,
      5,
      5,
      0
    };
    private static int[] CPDIST = new int[30]
    {
      1,
      2,
      3,
      4,
      5,
      7,
      9,
      13,
      17,
      25,
      33,
      49,
      65,
      97,
      129,
      193,
      257,
      385,
      513,
      769,
      1025,
      1537,
      2049,
      3073,
      4097,
      6145,
      8193,
      12289,
      16385,
      24577
    };
    private static int[] CPDEXT = new int[30]
    {
      0,
      0,
      0,
      0,
      1,
      1,
      2,
      2,
      3,
      3,
      4,
      4,
      5,
      5,
      6,
      6,
      7,
      7,
      8,
      8,
      9,
      9,
      10,
      10,
      11,
      11,
      12,
      12,
      13,
      13
    };
    private int mode;
    private int readAdler;
    private int neededBits;
    private int repLength;
    private int repDist;
    private int uncomprLen;
    private bool isLastBlock;
    private int totalOut;
    private int totalIn;
    private bool nowrap;
    private StreamManipulator input;
    private OutputWindow outputWindow;
    private InflaterDynHeader dynHeader;
    private InflaterHuffmanTree litlenTree;
    private InflaterHuffmanTree distTree;
    private Adler32 adler;

    public Inflater()
      : this(false)
    {
    }

    public Inflater(bool nowrap)
    {
      this.nowrap = nowrap;
      this.adler = new Adler32();
      this.input = new StreamManipulator();
      this.outputWindow = new OutputWindow();
      this.mode = nowrap ? 2 : 0;
    }

    public void Reset()
    {
      this.mode = this.nowrap ? 2 : 0;
      this.totalIn = this.totalOut = 0;
      this.input.Reset();
      this.outputWindow.Reset();
      this.dynHeader = (InflaterDynHeader) null;
      this.litlenTree = (InflaterHuffmanTree) null;
      this.distTree = (InflaterHuffmanTree) null;
      this.isLastBlock = false;
      this.adler.Reset();
    }

    private bool DecodeHeader()
    {
      int num1 = this.input.PeekBits(16);
      if (num1 < 0)
        return false;
      this.input.DropBits(16);
      int num2 = (num1 << 8 | num1 >> 8) & (int) ushort.MaxValue;
      if (num2 % 31 != 0)
        throw new FormatException("Header checksum illegal");
      if ((num2 & 3840) != Deflater.DEFLATED << 8)
        throw new FormatException("Compression Method unknown");
      if ((num2 & 32) == 0)
      {
        this.mode = 2;
      }
      else
      {
        this.mode = 1;
        this.neededBits = 32;
      }
      return true;
    }

    private bool DecodeDict()
    {
      for (; this.neededBits > 0; this.neededBits -= 8)
      {
        int num = this.input.PeekBits(8);
        if (num < 0)
          return false;
        this.input.DropBits(8);
        this.readAdler = this.readAdler << 8 | num;
      }
      return false;
    }

    private bool DecodeHuffman()
    {
      int freeSpace = this.outputWindow.GetFreeSpace();
      while (freeSpace >= 258)
      {
        switch (this.mode)
        {
          case 7:
            int symbol1;
            while (((symbol1 = this.litlenTree.GetSymbol(this.input)) & -256) == 0)
            {
              this.outputWindow.Write(symbol1);
              if (--freeSpace < 258)
                return true;
            }
            if (symbol1 < 257)
            {
              if (symbol1 < 0)
                return false;
              this.distTree = (InflaterHuffmanTree) null;
              this.litlenTree = (InflaterHuffmanTree) null;
              this.mode = 2;
              return true;
            }
            try
            {
              this.repLength = Inflater.CPLENS[symbol1 - 257];
              this.neededBits = Inflater.CPLEXT[symbol1 - 257];
              goto case 8;
            }
            catch (Exception ex)
            {
              throw new FormatException("Illegal rep length code");
            }
          case 8:
            if (this.neededBits > 0)
            {
              this.mode = 8;
              int num = this.input.PeekBits(this.neededBits);
              if (num < 0)
                return false;
              this.input.DropBits(this.neededBits);
              this.repLength += num;
            }
            this.mode = 9;
            goto case 9;
          case 9:
            int symbol2 = this.distTree.GetSymbol(this.input);
            if (symbol2 < 0)
              return false;
            try
            {
              this.repDist = Inflater.CPDIST[symbol2];
              this.neededBits = Inflater.CPDEXT[symbol2];
              goto case 10;
            }
            catch (Exception ex)
            {
              throw new FormatException("Illegal rep dist code");
            }
          case 10:
            if (this.neededBits > 0)
            {
              this.mode = 10;
              int num = this.input.PeekBits(this.neededBits);
              if (num < 0)
                return false;
              this.input.DropBits(this.neededBits);
              this.repDist += num;
            }
            this.outputWindow.Repeat(this.repLength, this.repDist);
            freeSpace -= this.repLength;
            this.mode = 7;
            continue;
          default:
            throw new FormatException();
        }
      }
      return true;
    }

    private bool DecodeChksum()
    {
      for (; this.neededBits > 0; this.neededBits -= 8)
      {
        int num = this.input.PeekBits(8);
        if (num < 0)
          return false;
        this.input.DropBits(8);
        this.readAdler = this.readAdler << 8 | num;
      }
      if ((int) this.adler.Value != this.readAdler)
        throw new FormatException("Adler chksum doesn't match: " + (object) (int) this.adler.Value + " vs. " + (object) this.readAdler);
      this.mode = 12;
      return false;
    }

    private bool Decode()
    {
      switch (this.mode)
      {
        case 0:
          return this.DecodeHeader();
        case 1:
          return this.DecodeDict();
        case 2:
          if (this.isLastBlock)
          {
            if (this.nowrap)
            {
              this.mode = 12;
              return false;
            }
            this.input.SkipToByteBoundary();
            this.neededBits = 32;
            this.mode = 11;
            return true;
          }
          int num1 = this.input.PeekBits(3);
          if (num1 < 0)
            return false;
          this.input.DropBits(3);
          if ((num1 & 1) != 0)
            this.isLastBlock = true;
          switch (num1 >> 1)
          {
            case 0:
              this.input.SkipToByteBoundary();
              this.mode = 3;
              break;
            case 1:
              this.litlenTree = InflaterHuffmanTree.defLitLenTree;
              this.distTree = InflaterHuffmanTree.defDistTree;
              this.mode = 7;
              break;
            case 2:
              this.dynHeader = new InflaterDynHeader();
              this.mode = 6;
              break;
            default:
              throw new FormatException("Unknown block type " + (object) num1);
          }
          return true;
        case 3:
          if ((this.uncomprLen = this.input.PeekBits(16)) < 0)
            return false;
          this.input.DropBits(16);
          this.mode = 4;
          goto case 4;
        case 4:
          int num2 = this.input.PeekBits(16);
          if (num2 < 0)
            return false;
          this.input.DropBits(16);
          if (num2 != (this.uncomprLen ^ (int) ushort.MaxValue))
            throw new FormatException("broken uncompressed block");
          this.mode = 5;
          goto case 5;
        case 5:
          this.uncomprLen -= this.outputWindow.CopyStored(this.input, this.uncomprLen);
          if (this.uncomprLen != 0)
            return !this.input.IsNeedingInput;
          this.mode = 2;
          return true;
        case 6:
          if (!this.dynHeader.Decode(this.input))
            return false;
          this.litlenTree = this.dynHeader.BuildLitLenTree();
          this.distTree = this.dynHeader.BuildDistTree();
          this.mode = 7;
          goto case 7;
        case 7:
        case 8:
        case 9:
        case 10:
          return this.DecodeHuffman();
        case 11:
          return this.DecodeChksum();
        case 12:
          return false;
        default:
          throw new FormatException();
      }
    }

    public void SetDictionary(byte[] buffer) => this.SetDictionary(buffer, 0, buffer.Length);

    public void SetDictionary(byte[] buffer, int off, int len)
    {
      if (!this.IsNeedingDictionary)
        throw new InvalidOperationException();
      this.adler.Update(buffer, off, len);
      if ((int) this.adler.Value != this.readAdler)
        throw new ArgumentException("Wrong adler checksum");
      this.adler.Reset();
      this.outputWindow.CopyDict(buffer, off, len);
      this.mode = 2;
    }

    public void SetInput(byte[] buf) => this.SetInput(buf, 0, buf.Length);

    public void SetInput(byte[] buf, int off, int len)
    {
      this.input.SetInput(buf, off, len);
      this.totalIn += len;
    }

    public int Inflate(byte[] buf) => this.Inflate(buf, 0, buf.Length);

    public int Inflate(byte[] buf, int off, int len)
    {
      if (len < 0)
        throw new ArgumentOutOfRangeException("len < 0");
      if (len == 0)
        return 0;
      int num = 0;
      do
      {
        if (this.mode != 11)
        {
          int len1 = this.outputWindow.CopyOutput(buf, off, len);
          this.adler.Update(buf, off, len1);
          off += len1;
          num += len1;
          this.totalOut += len1;
          len -= len1;
          if (len == 0)
            return num;
        }
      }
      while (this.Decode() || this.outputWindow.GetAvailable() > 0 && this.mode != 11);
      return num;
    }

    public bool IsNeedingInput => this.input.IsNeedingInput;

    public bool IsNeedingDictionary => this.mode == 1 && this.neededBits == 0;

    public bool IsFinished => this.mode == 12 && this.outputWindow.GetAvailable() == 0;

    public int Adler => this.IsNeedingDictionary ? this.readAdler : (int) this.adler.Value;

    public int TotalOut => this.totalOut;

    public int TotalIn => this.totalIn - this.RemainingInput;

    public int RemainingInput => this.input.AvailableBytes;
  }
}
